function doSpellCheck(editorName) {
    if (!SpellCheckEnabled) { 
        alert(noSpellCheckErrorMsg); 
        return; 
    }

	var useSelection = false;
    var bodyRange = null;
    var s1 = null;

    var rte_doc = IBM_RTE_getDocument(editorName);
    var body = rte_doc.body;
	var selectionRange = IBM_RTE_getSelectionRange(editorName);

 	// see if there is selection.
	if (isGecko()) {
		if (selectionRange && !selectionRange.collapsed) {
			useSelection = true;
		}
	} else {
		if (selectionRange && selectionRange.text.length > 0) {
			useSelection = true;
		}
	}

    if (useSelection) {
        // if there is selection, use the selected range as input
        input = selectionRange;
    
        if (IBM_RTE_isMozilla()) {
            s1 = input.toString();
        } else {
            s1 = input.htmlText;
        }
	} else {
	    // no selection, use the whole document range as input
        if (IBM_RTE_isMozilla()) {
            input = rte_doc.createRange();
            input.selectNodeContents(body);
            s1 = input.toString();
        }
        else {
            input = body.createTextRange();
            s1 = input.htmlText;
        }
    }
    
    // invoke spell check service
    try {
        var spr = new SpellCheckRange();
        spr.add(s1, input);
        SpellCheck.CheckSpelling(spr);
    } catch (e) {
        alert(e.message);
    }
}